name: Staging

on:
  push:
    branches: [ staging ]

jobs:
  setup:
    runs-on:
      - self-hosted
      - staging

    environment: staging

    env:
      PORT: ${{ secrets.PORT }}
      APP_NAME: ${{ secrets.APP_NAME }}
      NODE_AUTH_TOKEN: ${{ secrets.NPM_AUTH_TOKEN }}
      NEXT_PUBLIC_URL_API: ${{ secrets.NEXT_PUBLIC_URL_API }}

    steps:
    - uses: actions/checkout@v3
    - uses: actions/setup-node@v3
      with:
        always-auth: true
        node-version-file: .nvmrc
        registry-url: https://npm.pkg.github.com
        scope: '@mintlayer'
    - name: Install dependencies and build with NextJs
      run: |
        yarn --frozen-lockfile
        yarn add --dev typescript
        yarn build
        yarn remove typescript
        rsync -avzh --exclude='.git' . /home/fatima/$APP_NAME
    - name: Deploy with PM2
      run: |
        cd /home/fatima/$APP_NAME
        pm2 restart ecosystem.config.js && pm2 save
